/* WireCull.h */
#ifndef WIRECULL_H
  #define WIRECULL_H

  #include <conio.h>
  #include <math.h>
  #include <stdlib.h>
  #include "conDraw.h"
  #include "GrafOps.h" 
  #include "lineOps.h" 
  #include "LoadCGF.h"
  #include "MatrOps.h" 

  #define ESC        27
  #define CGF_FILE01 "..\\..\\_Dat\\Xface.cgf"
  #define CGF_FILE02            ".\\Xface.cgf"
  #define CGF_FILE11 "..\\..\\_Dat\\cube.cgf"
  #define CGF_FILE12            ".\\cube.cgf"
  #define CGF_FILE21 "..\\..\\_Dat\\house.cgf"
  #define CGF_FILE22            ".\\house.cgf"
  #define CGF_FILE41 "..\\..\\_Dat\\cylinder.cgf"
  #define CGF_FILE42            ".\\cylinder.cgf"
  #define CGF_FILE51 "..\\..\\_Dat\\sphere20.cgf"
  #define CGF_FILE52            ".\\sphere20.cgf"

  #pragma warning(disable : 4996) // ("veraltet" nicht mehr melden!)

  /*Prototypen:*/
  void  conBBox       (CGFobject *obj);
  int   conDrawCGFobj (CGFobject *obj, float eyez);
  void  conInit       (void);
  void  conViewport   (float *posMat);
  void  draw          (void);
  void  initPos       (CGFobject *obj);
  void  key           (char k);

#endif  //WIRECULL_H
