/* LoadCGF.c */
/*Funktionen fuer CGF-Dateien Vers. 0.1*/
#include "LoadCGF.h"

#define MORE_LOAD
#define MORE_PRNT

/* *********************************************************************** */
   int loadCGF (CGFobject *obj, char *filnam)
/* *********************************************************************** */
/* Laden eines 3D-Objektes aus einer *.CGF-Datei */
{ int  jj1=0, jj2=0; 
  FILE *filecgf=NULL;
  char dummyc[LENGTH];
#ifdef  MORE_LOAD // weitere Variablen:
#endif//MORE_LOAD

  /*Datei nur zum Lesen oeffnen, Objekt-Name lesen:
  (d.h. alles bis zum ersten Leerzeichen, Semikolon oder Zeilenwechsel):*/
  if ((filecgf=fopen(filnam, "r"))==NULL) return(0);
#ifdef  MORE_LOAD
#endif//MORE_LOAD

  /*Anzahl Objektpunkte lesen:*/
  fscanf(filecgf, "%d", &(obj->nVrtx)); 
  fgets(dummyc, LENGTH, filecgf); /*Zeilen-Rest*/

  /*Speicherplatz fuer Objektpunkte reservieren:*/
#ifdef  MORE_LOAD
#endif//MORE_LOAD
  if (!obj->Vrtx)
     { printf (" loadCGF: kein Speicher fuer Vrtx!"); return (0); }
 
  /*Objektpunkt-Koordinaten lesen:*/
  for (jj1=0; jj1 < obj->nVrtx; jj1++)
  { 
#ifdef  MORE_LOAD
#endif//MORE_LOAD
  } 

  /*Flaechen, ihre Symbole und Anzahl Eckpunkte:*/
  fscanf(filecgf, "%d", &(obj->nFace)); 
  fgets(dummyc, LENGTH, filecgf); /*Zeilen-Rest*/
  obj->Face = (Polygon*) calloc (obj->nFace, sizeof(Polygon));
  if (!obj->Face)
  { printf (" loadCGF: kein Speicher fuer Face!"); return (0); }

  /*Jeder Flaeche ein Symbol zuordnen und Anzahl Eckpunkte lesen:*/
  for (jj1=0; jj1<obj->nFace; jj1++)
  { obj->Face[jj1].symbol = '\60'+(char)jj1;  // ab '0'

#ifdef  MORE_LOAD
#endif//MORE_LOAD
  } fgets(dummyc, LENGTH, filecgf); /*Zeilen-Rest*/

  /*Speicher fuer Flaechenpkte, Zuordnung zu Objektpkten:*/
  for (jj1=0; jj1 < obj->nFace; jj1++)
  {
#ifdef  MORE_LOAD
#endif//MORE_LOAD
  }
  /*... und aufrufende Fkt setzt Positionierungsmatrix*/
  fclose (filecgf);
  return (1);
}

#define WIRKUNGSGLEICH

/* *********************************************************************** */
   int printCGF (CGFobject *obj)
/* *********************************************************************** */
{ /*Ausgabe der Werte in der Struktur eines CGF-Objektes:*/
  int jj1=0, jj2=0, jj3=0;

#ifdef  MORE_PRNT
#endif//MORE_PRNT

  return (1);
}
